#!/usr/bin/php5
<?php
/**
 * ------------------------------------------------------------------------
 * BlueMind Stats Portal, aka bm-stats
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
 * ------------------------------------------------------------------------
 **/
 
require("/usr/share/bm-stats/www/conf/config.php");
require("/usr/share/bm-stats/www/function/dir_file.php");
require("/usr/share/bm-stats/www/function/lang.php");
require("/usr/share/bm-stats/www/function/date.php");

$path_to_pChart = "/usr/share/bm-stats/scripts/PHP/pChart/" ;


if(date("z") == "0" ) { 
    $this_year = date("Y") - 1 ; 
} else { 
    $this_year = date("Y"); 
};

$mktime_yesterday = mktime(0,0,0,date("m"),date("d")-1,date("y"));
$this_year  = date("Y",$mktime_yesterday);
$this_month = date("m",$mktime_yesterday);


function get_domainList() {

    Global $path_to_data;

    $noThis = array(".","..","general");
    $thisDomainList = array() ;
   
    if ($handle = opendir($path_to_data)) {
        while(false !== ($entry = readdir($handle))) {
            
            if(!in_array($entry,$noThis)) {
                
                if(is_file($path_to_data."/".$entry."/realTime.dat")) {
                    $thisDomainList[] = $entry;
                };
            };
        }; 
      
        closedir($handle);                                                                        
    };    
    
    return $thisDomainList ;
};  


function readDomainQuotaDatFile($domain) {
    Global $path_to_data ; 

    $thisArray = array(); 
    $thisArray[spaceRatio] = array("-1"=>0, "50"=>0, "80"=>0, "80"=>0, "90"=>0, "100"=>0, "101"=>0);

    $thisFile = $path_to_data.$domain."/userQuota.dat" ;

    $line = file($thisFile);

    foreach ($line as $thisLine) {
        $ratio = 'ND' ;
        /*
        file struct + exemple
        mbox,used space, applied quota
        reporting,136,51200
        */

        $values = explode(",", $thisLine);
         $mbox  = $values[0];
         $space = $values[1];
         $quota = $values[2];
        
        if ($quota != 0) 
            $ratio =  floor(($space/$quota)*10000)/100;
        
        $thisArray[mbox][$mbox][0] = $space ;
        $thisArray[mbox][$mbox][1] = $quota ;
        $thisArray[mbox][$mbox][2] = $ratio ;
        
        if ($ratio == 'ND')
            $thisArray[spaceRatio][-1]++ ;

        if( ($ratio !='ND') and ($ratio <= 50) ) 
            $thisArray[spaceRatio][50]++ ;

        if( ($ratio > 50) and ($ratio <= 80))
            $thisArray[spaceRatio][80]++ ;
    
        if( ($ratio > 80) and ($ratio <= 90))
            $thisArray[spaceRatio][90]++ ;
    
        if( ($ratio > 90) and ($ratio < 100))
            $thisArray[spaceRatio][100]++ ;

        if($ratio >= 100)
            $thisArray[spaceRatio][101]++ ;
    }

    return $thisArray ;

};


function grapheDomainQuotaDatFile($thisArray,$domain){
    
    Global  $path_to_data, $l_cyrusUnlimQuota, $l_cyrusQuotaOverview;

    $title = "$domain : $l_cyrusQuotaOverview";
    $path_to_pChart = "/usr/share/bm-stats/scripts/PHP/pChart/" ;


    require_once($path_to_pChart."class/pData.class.php");
    require_once($path_to_pChart."class/pDraw.class.php");
    require_once($path_to_pChart."class/pImage.class.php");
    require_once($path_to_pChart."class/pIndicator.class.php");
    
    verif_existence_rep($path_to_data.$domain."/img");    
    $img = $path_to_data.$domain."/img/cyrusQuotaSurvey.png";

    
    $ND      = $thisArray[spaceRatio][-1] ;
    $inf50   = $thisArray[spaceRatio][50] ;
    $inf80   = $thisArray[spaceRatio][80] ;
    $inf90   = $thisArray[spaceRatio][90] ;
    $inf100  = $thisArray[spaceRatio][100];
    $over100 = $thisArray[spaceRatio][101];
    
   
    $posND      = $ND; 
    $posInf50   = $posND + $inf50 ;
    $posInf80   = $posInf50 + $inf80 ;
    $posInf90   = $posInf80 + $inf90 ;
    $posInf100  = $posInf90 + $inf100 ;
    $posOver100 = $posInf100 + $over100 ;
 
    $NDTitle      = "$ND $l_cyrusUnlimQuota";
    $inf50Title   = "$inf50 mbox <=50%";
    $inf80Title   = "$inf80 mbox <=80%";
    $inf90Title   = "$inf90 mbox <=90%";
    $inf100Title  = "$inf100 mbox <100%";
    $over100Title = "$over100 mbox overquota";
    
    /* Create the pChart object */
    $myPicture = new pImage(900,150,$MyData);
    
    $myPicture->drawGradientArea(0,0,900,150,DIRECTION_VERTICAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>166,"EndG"=>202,"EndB"=>219,"Alpha"=>100));
    $myPicture->drawGradientArea(0,0,900,20,DIRECTION_HORIZONTAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>10,"EndG"=>85,"EndB"=>133,"Alpha"=>100));
    
    $myPicture->drawLine(0,20,900,20,array("R"=>255,"G"=>255,"B"=>255));
    $RectangleSettings = array("R"=>180,"G"=>180,"B"=>180,"Alpha"=>100);
 
    /* Add a border to the picture */
    $myPicture->drawRectangle(0,0,899,149,array("R"=>0,"G"=>0,"B"=>0));
 
    /* Write the picture title */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    $myPicture->drawText(10,15,$title,array("R"=>255,"G"=>255,"B"=>255));
 
    /* Set the default font properties */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>10,"R"=>80,"G"=>80,"B"=>80));
 
    /* Enable shadow computing */
    $myPicture->setShadow(TRUE,array("X"=>2,"Y"=>2,"R"=>0,"G"=>0,"B"=>0,"Alpha"=>10));
    
    /* Create the pIndicator object */ 
    $Indicator = new pIndicator($myPicture);

    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8,"R"=>0,"G"=>0,"B"=>0));

    /* Define the indicator sections */
    $IndicatorSections   = "";
    $IndicatorSections[] = array("Start"=>0,"End"=>$posND,"Caption"=>$NDTitle,"R"=>0,"G"=>142,"B"=>176);
    $IndicatorSections[] = array("Start"=>$posND,"End"=>$posInf50,"Caption"=>$inf50Title,"R"=>24,"G"=>196,"B"=>52);
    
    if( $inf80 > 0 )
        $IndicatorSections[] = array("Start"=>$posInf50,"End"=>$posInf80,"Caption"=>$inf80Title,"R"=>207,"G"=>235,"B"=>93);    

    if( $inf90 > 0 )
        $IndicatorSections[] = array("Start"=>$posInf80,"End"=>$posInf90,"Caption"=>$inf90Title,"R"=>242,"G"=>173,"B"=>7);
    
    if( $inf100 > 0 )
        $IndicatorSections[] = array("Start"=>$posInf90,"End"=>$posInf100,"Caption"=>$inf100Title,"R"=>242,"G"=>90,"B"=>7);
    
    if( $over100 > 0) 
        $IndicatorSections[] = array("Start"=>$posInf100,"End"=>$posOver100,"Caption"=>$over100Title,"R"=>255,"G"=>0,"B"=>0);

    /* Draw the 1st indicator */
    $IndicatorSettings = array(
            "ValueDisplay"=>FALSE,
            "DrawLeftHead"=>FALSE, 
            "CaptionPosition"=>INDICATOR_CAPTION_BOTTOM, 
            "CaptionLayout"=>INDICATOR_CAPTION_DEFAULT,
            "IndicatorSections"=>$IndicatorSections,
            "SubCaptionColorFactor"=>-40
            );
    $Indicator->draw(40,40,800,40,$IndicatorSettings);
    
    
    /* Write the picture title */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    $myPicture->drawText(10,15,$title,array("R"=>255,"G"=>255,"B"=>255));
    
    /* Write the Service*/
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    $myPicture->drawText(760,145,"[ ".date("d/m/Y H:i:s")." ] ",array("R"=>2,"G"=>2,"B"=>2));
    $myPicture->drawFromPNG(5,102,"/usr/share/bm-stats/scripts/PHP/do_graph/logo-bluemind.png");
    
    
    /* Render the picture */
    $myPicture->Render($img);

};

/*

*/

function SetXScaleDate($value) {
    $jour = substr($value,8,2);
    $mois = substr($value,5,2);

    if($jour == "01") {
        $xscaled = $jour." ".get_month($mois) ;
    } else {    
        $xscaled = " " ;
    };
       
    return $xscaled ;
};



function setMo($value) {
    return round($value).' Mo';
};

function setRoundValue($value) {
        return round($value) ;
};

/*
Read and return data stored in /var/lib/bm-stats/general/quotaH24.dat
*/

function readAllDomainQuotaFileDat() {
    
    Global $path_to_data,$this_year,$this_month ; 

    $thisArray = array() ;
    
    $thisFile = $path_to_data."general/allDomainQuotaFile.dat" ;
    
    $line = file($thisFile) ;
    
    if( !empty($line)) {
        
        foreach ($line as $thisLine) {
            if(preg_match("/(\d+)-(.*);(.*),(.*)/", $thisLine, $val )) {
                
                $mktime = $val[1] ;
                    $date = date("Y-m-d", $mktime);
                    $this_X_dot = SetXScaleDate($date);
                    $element = explode("-",$date);
                    $element_year   = $element[0];         
                    $element_month  = $element[1];
                    $element_day    = $element[2];                     
                
                $domain = $val[3] ;
                $size   = floor($val[4]/1000) ; // because graph in Mo
                
                $thisArray[$domain]['y']['date'][] = $this_X_dot ;
                $thisArray[$domain]['y']['size'][] = $size ;
                
                if( ($this_year==$element_year) and  ($this_month==$element_month) ) {        
                    $thisArray[$domain]['m']['date'][] = $element_day;
                    $thisArray[$domain]['m']['size'][] = $size ;
                };
            }
        }
    }
    
    return $thisArray ;
}

/*
array $values : extraction de la tables MySQL faite par get_values().
$domain       : autre que GlobalServer & Externe
*/
function grapheGeneralCyrusSpaceOccupation($values,$domain,$type) {
    Global $this_year,$this_week,$this_month,$this_n_day  ;
    Global $path_to_data,$path_to_pChart,$case_img;        
    Global $do_graph_domain, $do_graph_global_server, $do_graph_external_server;

    $path_to_img = $path_to_data.$domain."/img/".$this_year."/";
   

    /* pChart library inclusions */
    require_once $path_to_pChart."class/pData.class.php";
    require_once $path_to_pChart."class/pDraw.class.php";
    require_once $path_to_pChart."class/pImage.class.php";


 
    // Ctrl existance du dossier image
    verif_existence_rep($path_to_img);

    $y1_title = "Domaine  $domain ";
    $y2_title = "Global Serveur";

    if($type=="y") {
        $x     = $values[$domain]['y']['date'];
        $y1    = $values[$domain]['y']['size'];
        $y2    = $values['Global']['y']['size'];
        $title = $case_img['size']['titley'] ;
        $img   = $path_to_img."Y".$this_year."_cyrusSpaceSurvey.png" ;
    };

    if($type=="m") {
        $x     = $values[$domain]['m']['date'];
        $y1    = $values[$domain]['m']['size'];
        $y2    = $values['Global']['m']['size'];
        $title = $case_img['size']['titlem'] ;
        $img   = $path_to_img."M".$this_month."_cyrusSpaceSurvey.png" ;
    };

    $MyData = new pData();
    $MyData->addPoints($y1,$y1_title);
    $y1_colorscheme = array("R"=>15,"G"=>44,"B"=>52,"Alpha"=>80);
    $MyData->setPalette($y1_title,$y1_colorscheme);
    

    $MyData->addPoints($y2,$y2_title);
    $y2_colorscheme = array("R"=>184,"G"=>0,"B"=>40,"Alpha"=>80);
    $MyData->setPalette($y2_title,$y2_colorscheme);

    $MyData->addPoints($x,"Labels");
    $MyData->setSerieDescription("Labels","Month");
    $MyData->setAbscissa("Labels");

    /* Create the pChart object */
    $myPicture = new pImage(1000,300,$MyData);

    $myPicture->drawGradientArea(0,0,1000,300,DIRECTION_VERTICAL,array("StartR"=>166,"StartG"=>202,"StartB"=>219,"EndR"=>0,"EndG"=>75,"EndB"=>123,"Alpha"=>100));     
    $myPicture->drawGradientArea(0,250,1000,300,DIRECTION_VERTICAL,array("StartR"=>0,"StartG"=>75,"StartB"=>123,"EndR"=>166,"EndG"=>202,"EndB"=>219,"Alpha"=>100));


    $myPicture->drawLine(0,249,1000,249,array("R"=>0,"G"=>0,"B"=>0));
    $myPicture->drawLine(0,250,1000,250,array("R"=>70,"G"=>70,"B"=>70));

    /* Add a border to the picture */
    $myPicture->drawRectangle(0,0,999,299,array("R"=>204,"G"=>204,"B"=>204));

    /* Write the picture title */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    $myPicture->drawText(500,14,$title,array("R"=>47,"G"=>47,"B"=>47,"Align"=>TEXT_ALIGN_MIDDLEMIDDLE));

    /* Define the chart area */
    $myPicture->setGraphArea(58,27,980,228);

    /* Draw a rectangle */
    $myPicture->drawFilledRectangle(58,27,980,228,array("R"=>180,"G"=>180,"B"=>180,"Dash"=>TRUE,"DashR"=>250,"DashG"=>250,"DashB"=>250,"BorderR"=>150,"BorderG"=>150,"BorderB"=>150));

    /* Turn on shadow computing */
    $myPicture->setShadow(TRUE,array("X"=>1,"Y"=>1,"R"=>0,"G"=>0,"B"=>0,"Alpha"=>20));

    /* Draw the scale */
    $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
    $ScaleSettings = array("DrawArrows"=>TRUE,"ArrowSize"=>4,"DrawXLines"=>FALSE,"Mode"=>SCALE_MODE_ADDALL_START0,"DrawSubTicks"=>FALSE,"GridR"=>0,"GridG"=>0,"GridB"=>0,"AxisR"=>0,"AxisG"=>0,"AxisB"=>0,"GridAlpha"=>30,"CycleBackground"=>TRUE);

    $myPicture->drawScale($ScaleSettings);

    /* Draw the spline chart */
    $myPicture->drawSplineChart();

    /* Write the chart boundaries */
    $BoundsSettings = array("MaxDisplayR"=>237,"MaxDisplayG"=>23,"MaxDisplayB"=>48,"MinDisplayR"=>23,"MinDisplayG"=>144,"MinDisplayB"=>237);
    $myPicture->writeBounds(BOUND_BOTH,$BoundsSettings);

    /* Write the chart legend */
    $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
    $myPicture->drawLegend(450,258,array("Style"=>LEGEND_NOBORDER));

    //number_format(, 2, '.', '')

    /* Write the 1st data series statistics */
    $Settings = array("R"=>15,"G"=>44,"B"=>52,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
    $myPicture->drawText(620,265,"Max : ".number_format(ceil($MyData->getMax($y1_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(700,265,"Min : ".number_format(ceil($MyData->getMin($y1_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(780,267,"Avg : ".number_format(ceil($MyData->getSerieAverage($y1_title)), 0, '.', ' '),$Settings);
    //$myPicture->drawText(860,265,"Tot : ".number_format(ceil(array_sum($y1)), 0, '.', ' '),$Settings);

    /* Write the 2nd data series statistics */
    $Settings = array("R"=>184,"G"=>0,"B"=>40,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
    $myPicture->drawText(620,278,"Max : ".number_format(ceil($MyData->getMax($y2_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(700,278,"Min : ".number_format(ceil($MyData->getMin($y2_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(780,280,"Avg : ".number_format(ceil($MyData->getSerieAverage($y2_title)), 0, '.', ' '),$Settings);
    //$myPicture->drawText(860,278,"Tot : ".number_format(ceil(array_sum($y2)), 0, '.', ' '),$Settings);

    /* Write the Service*/
    $myPicture->drawFromPNG(5,249,"/usr/share/bm-stats/scripts/PHP/do_graph/logo-bluemind.png");

    /* Render the picture (choose the best way) */
    $myPicture->render($img);
   
};

/*
Read and return data stored in /var/lib/bm-stats/general/quotaH24.dat
*/

function readQuotaH24FileDat() {
    
    Global $path_to_data,$this_year,$this_month ; 

    $thisArray = array() ;
    
    $thisFile = $path_to_data."general/quotaH24.dat" ;
    
    $line = file($thisFile) ;
    
    if( !empty($line)) {
        
        foreach ($line as $thisLine) {
            if(preg_match("/(\d+)-(.*);(.*),(.*)/", $thisLine, $val )) {
                
                $mktime = $val[1] ;
                    $hour = date("H",$mktime) ;
                    $min  = date("i",$mktime) ;
                
                $domain = $val[3] ;
                $size   = floor($val[4]/1000) ; // because graph in Mo
                
                //$thisArray[$domain]['x'][$mktime] = "";
                //if($min == '00') {
                    $thisArray[$domain]['x'][$mktime] = "$hour:$min" ;
                //};
                
                $thisArray[$domain]['y'][$mktime] = $size ; 
            }
        }
    }
    
    return $thisArray ;
}

function grapheH24CyrusSpaceOccupation($values,$domain) {

    Global $path_to_data,$path_to_pChart;        
    Global $do_graph_domain, $do_graph_global_server, $do_graph_external_server;
    Global $l_H24CyrusSpaceOccupation_title, $l_H24CyrusSpaceOccupation_titled;
    
    $path_to_img = $path_to_data.$domain."/img/";
   
    $thisHour = date("H:") ;
    $mktime_yesterday = mktime(0,0,0,date("m"),date("d")-1,date("y"));
        $this_year  = date("Y",$mktime_yesterday);
        $this_month = date("m",$mktime_yesterday);
        $this_n_day   = date("z",$mktime_yesterday);

    /* pChart library inclusions */
    require_once $path_to_pChart."class/pData.class.php";
    require_once $path_to_pChart."class/pDraw.class.php";
    require_once $path_to_pChart."class/pImage.class.php";

    $this_lit_month = get_month($this_month); 
        $this_full_day = date("d",$mktime_yesterday)." ".$this_lit_month." ".$this_year;


    /* Liste des titres dans les graphes */
    $title  = $l_H24CyrusSpaceOccupation_title;
       
    if( $thisHour == "00:" ) 
        $title  = $l_H24CyrusSpaceOccupation_titled." $this_full_day";
 
    // Ctrl existance du dossier image
    verif_existence_rep($path_to_img);

    $y1_title = "Domaine  $domain ";
    $y2_title = "Global Serveur";

    $x     = $values[$domain]['x'];
    $y1    = $values[$domain]['y'] ;
    $y2    = $values['Global']['y'];
    $img   = $path_to_img."cyrusSpaceSurvey.png" ;

    $MyData = new pData();
    $MyData->addPoints($y1,$y1_title);
    $y1_colorscheme = array("R"=>15,"G"=>44,"B"=>52,"Alpha"=>80);
    $MyData->setPalette($y1_title,$y1_colorscheme);
    

    $MyData->addPoints($y2,$y2_title);
    $y2_colorscheme = array("R"=>184,"G"=>0,"B"=>40,"Alpha"=>80);
    $MyData->setPalette($y2_title,$y2_colorscheme);

    $MyData->addPoints($x,"Labels");
    $MyData->setSerieDescription("Labels","Month");
    $MyData->setAbscissa("Labels");

    /* Create the pChart object */
    $myPicture = new pImage(1000,300,$MyData);

    $myPicture->drawGradientArea(0,0,1000,300,DIRECTION_VERTICAL,array("StartR"=>166,"StartG"=>202,"StartB"=>219,"EndR"=>0,"EndG"=>75,"EndB"=>123,"Alpha"=>100));     
    
    $myPicture->drawLine(0,249,1000,249,array("R"=>0,"G"=>0,"B"=>0));
    $myPicture->drawLine(0,250,1000,250,array("R"=>70,"G"=>70,"B"=>70));

    /* Add a border to the picture */
    $myPicture->drawRectangle(0,0,999,299,array("R"=>204,"G"=>204,"B"=>204));

    /* Write the picture title */
    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>8));
    $myPicture->drawText(500,14,$title,array("R"=>47,"G"=>47,"B"=>47,"Align"=>TEXT_ALIGN_MIDDLEMIDDLE));

    /* Define the chart area */
    $myPicture->setGraphArea(58,27,980,228);

    /* Draw a rectangle */
    $myPicture->drawFilledRectangle(58,27,980,228,array("R"=>180,"G"=>180,"B"=>180,"Dash"=>TRUE,"DashR"=>250,"DashG"=>250,"DashB"=>250,"BorderR"=>150,"BorderG"=>150,"BorderB"=>150));

    /* Turn on shadow computing */
    $myPicture->setShadow(TRUE,array("X"=>1,"Y"=>1,"R"=>0,"G"=>0,"B"=>0,"Alpha"=>20));

    /* Draw the scale */
    $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
    $ScaleSettings = array("DrawArrows"=>TRUE,"ArrowSize"=>4,"Mode"=>SCALE_MODE_ADDALL_START0,"DrawSubTicks"=>FALSE,"GridR"=>0,"GridG"=>0,"GridB"=>0,"AxisR"=>0,"AxisG"=>0,"AxisB"=>0,"GridAlpha"=>30,"CycleBackground"=>TRUE);

    $myPicture->drawScale($ScaleSettings);

    /* Draw the spline chart */
    $myPicture->drawSplineChart();

    /* Write the chart boundaries */
    $BoundsSettings = array("MaxDisplayR"=>237,"MaxDisplayG"=>23,"MaxDisplayB"=>48,"MinDisplayR"=>23,"MinDisplayG"=>144,"MinDisplayB"=>237);
    $myPicture->writeBounds(BOUND_BOTH,$BoundsSettings);

    /* Write the chart legend */
    $myPicture->setFontProperties(array("R"=>47,"G"=>47,"B"=>47));
    $myPicture->drawLegend(450,258,array("Style"=>LEGEND_NOBORDER));

    //number_format(, 2, '.', '')

    /* Write the 1st data series statistics */
    $Settings = array("R"=>15,"G"=>44,"B"=>52,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
    $myPicture->drawText(700,265,"Max : ".number_format(ceil($MyData->getMax($y1_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(780,265,"Min : ".number_format(ceil($MyData->getMin($y1_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(860,267,"Avg : ".number_format(ceil($MyData->getSerieAverage($y1_title)), 0, '.', ' '),$Settings);
    //$myPicture->drawText(860,265,"Tot : ".number_format(ceil(array_sum($y1)), 0, '.', ' '),$Settings);

    /* Write the 2nd data series statistics */
    $Settings = array("R"=>184,"G"=>0,"B"=>40,"Align"=>TEXT_ALIGN_BOTTOMLEFT);
    $myPicture->drawText(700,278,"Max : ".number_format(ceil($MyData->getMax($y2_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(780,278,"Min : ".number_format(ceil($MyData->getMin($y2_title)), 0, '.', ' '),$Settings);
    $myPicture->drawText(860,280,"Avg : ".number_format(ceil($MyData->getSerieAverage($y2_title)), 0, '.', ' '),$Settings);
    //$myPicture->drawText(860,278,"Tot : ".number_format(ceil(array_sum($y2)), 0, '.', ' '),$Settings);

    /* Write the Service*/
    $myPicture->drawFromPNG(5,249,"/usr/share/bm-stats/scripts/PHP/do_graph/logo-bluemind.png");

    $myPicture->setFontProperties(array("FontName"=>$path_to_pChart."fonts/verdana.ttf","FontSize"=>7));
    $myPicture->drawText(870,295,"[ ".date("d/m/Y H:i:s")." ] ",array("R"=>255,"G"=>255,"B"=>255));
    
    /* Render the picture (choose the best way) */
    $myPicture->render($img);
    
    if( $thisHour == "00:" ) {
        $imgBackup = $path_to_data.$domain."/img/".$this_year."/D".$this_n_day."_cyrusSpaceSurvey.png" ;
        copy($img, $imgBackup);
    };
   
};

/*  */

$thisDomainList = get_domainList() ;

$cyrusH24Sizevalues = readQuotaH24FileDat() ;

if(date("H") == "00" )
    $cyrusSizeValues = readAllDomainQuotaFileDat() ;


    
foreach ($thisDomainList as $domain) {

    $myLang = getLang($domain) ;
    if(!empty($myLang)) $lang=$myLang ;

    require("/usr/share/bm-stats/www/inc_lang/inc_lang_$lang.php");

    $thisArray = readDomainQuotaDatFile($domain);
    grapheDomainQuotaDatFile($thisArray,$domain);

    grapheH24CyrusSpaceOccupation($cyrusH24Sizevalues,$domain) ;
    
    
    if(date("H") == '00' ) {
        
        $this_lit_month = get_month($this_month); 
        $this_full_day = date("d",$mktime_yesterday)." ".$this_lit_month." ".$this_year;

        $case_img = array(    
                        "size" => array(    
                            "titley" => "$do_graph_cyrusSize_titley $this_year",
                            "titlem" => "$do_graph_cyrusSize_titlem $this_lit_month $this_year",
                        )
                    ); 
        
        grapheGeneralCyrusSpaceOccupation($cyrusSizeValues,$domain,$type='m');
        grapheGeneralCyrusSpaceOccupation($cyrusSizeValues,$domain,$type='y');
    }
    
    
};

?>